//Analysis Type - TS_Class 
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <stdlib.h>


double input_hidden_weights[7][2]=
{
 {-2,86968937407585e-001, 3,03645300290204e-001 },
 {2,63476378671057e-002, -1,23567119359565e-001 },
 {6,78315802147161e-001, -7,46892759442940e-001 },
 {-4,77818249085864e-002, 4,88235598145495e-002 },
 {-1,24915521155233e+000, 1,32851792778866e+000 },
 {4,86888088006094e-001, -4,75240049193538e-001 },
 {6,88223067289009e-001, -5,93810050571157e-001 } 
};

double hidden_bias[7]={ -1,08605210641781e-001, -1,58553657346923e-001, 2,06997411668930e-002, -5,00811723586675e-002, 1,44109246886941e-001, 3,83204928041837e-002, -7,48055171385599e-002 };

double hidden_output_wts[2][7]=
{
 {-1,99591848069815e+000, -2,72877644417035e-001, 2,30025218825681e-001, 7,95445052481467e-001, 6,65813975141782e-003, -8,17640776506198e-001, 2,97107669536150e+000 },
 {2,30258294325091e+000, 3,69995824261448e-001, -2,38469113873152e-002, -6,82561639614988e-001, 1,98074137052238e-001, 1,03468543472242e+000, -2,91577762084399e+000 }
};

double output_bias[2]={ -2,44862113897915e-001, 7,17131689520634e-001 };

double input[2];
double hidden[7];
double output[2];

double logistic(double x)
{
  if(x > 100.0) x = 1.0;
  else if (x < -100.0) x = 0.0;
  else x = 1.0/(1.0+exp(-x));
  return x;
}

void ComputeFeedForwardSignals(double* MAT_INOUT,double* V_IN,double* V_OUT, double* V_BIAS,int size1,int size2,int layer)
{
  int row,col;
  for(row=0;row < size2; row++) 
    {
      V_OUT[row]=0.0;
      for(col=0;col<size1;col++)V_OUT[row]+=(*(MAT_INOUT+(row*size1)+col)*V_IN[col]);
      V_OUT[row]+=V_BIAS[row];
      if(layer==0) V_OUT[row] = logistic(V_OUT[row]);
      if(layer==1) V_OUT[row] = tanh(V_OUT[row]);
   }
}

void RunNeuralNet_TS_Class () 
{
  ComputeFeedForwardSignals((double*)input_hidden_weights,input,hidden,hidden_bias,2, 7,0);
  ComputeFeedForwardSignals((double*)hidden_output_wts,hidden,output,output_bias,7, 2,1);
}

int main()
{
  float dummy;
  int index;
  int i=0;
  int keyin=1;
  double max;
  int stepcntr;
  int inputindex;
  int nsteps;
  while(1)
  {
	max=3.e-300;
	stepcntr=1;
	inputindex=0;
    for(nsteps=0;nsteps<1;nsteps++)
    {
	 printf("Enter a value for Categorical inputs");
	 printf("\nCategorical Input Name: Dati\n");
     printf("\nCategories    NumericValues:\n");
	 printf("0           1\n");
	 printf("1           2\n");
l1: printf("Enter a valid numeric value:");
    scanf("%f",&dummy);
    if(dummy!=1 && dummy!=2)goto l1;
	 if(dummy==1)input[inputindex++]=1;
	 else input[inputindex++]=0;
	 if(dummy==2)input[inputindex++]=1;
	 else input[inputindex++]=0;
    }
	RunNeuralNet_TS_Class();
	for(i=0;i<2;i++)
	{
      if(max<output[i])
      {
        max=output[i];
        index=i+1;
      }
	}
	printf("\nPredicted category = ");

    switch(index)
    {
        case 1: printf("0\n"); break;
        case 2: printf("1\n"); break;
        default: break;
    }
    printf("\nConfidence level = %.14f",max);
	printf("\n\nPress any key to make another prediction or enter 0 to quit the program.\n");
	keyin=getch();
	if(keyin==48)break;
  }
	return 0;
}

